(in-package :cl-ansys)

(defconstant +E-regexp+ "(-{0,1}[0-9]\.[0-9]+(E[+-][0-9]{2}){0,1})"
  "Regexp to read a number of the format [-]X.X...[E+/-XX]")
(defconstant +flt-regexp+ "[0-9]+\.[0-9]+"
  "Regexp to read a floating point number of the format X.X...")

(defun regexp (fields)
  (format nil " +(~a) +  {0,1}~t~{ {0,1}~a~}.*" 
	  +flt-regexp+ 
	  (loop for i=0 below fields
	     collect +E-regexp+)))

(defmacro with-path-data ((stream (s h ex ey)) &body body)
  (dolines (line stream)
    (ppcre:register-groups-bind (s1 hz1 hz-exp ex1 ex-exp ey1 ey-exp)
	((regexp 3) line)
      (push (read-from-string s1) s)
      (push (read-from-string hz1) hz)
      (push (read-from-string ex1) ex)
      (push (read-from-string ey1) ey)))
  (setf s (nreverse s)
	h (nreverse h)
	ex (nreverse ex)
	ey (nreverse ey))


#|
(with-input-file (stream "midplane-1800MHz-im-h,ex,ey.dat")
  (dolines (line stream)
    (ppcre:register-groups-bind (s hz hz-exp ex ex-exp ey ey-exp)
	((regexp 3) line)
      (format t "~a ~a ~a ~a ~%" s hz ex ey))))
|#
